﻿using C1.Win.C1Input;
using System.Threading.Tasks;
using System;
using System.Windows.Forms;

namespace Input_DateTime
{
    internal class MyDateEdit : C1DateEdit
    {
        public DateTime? SelectedDate 
        { 
            get
            {
                if(DateTime.TryParse(this.Text, out DateTime val))
                    return val;
                return null;
            }
        }

        bool _cancelEdit;

        protected override void OnKeyUp(KeyEventArgs e)
        {
            base.OnKeyUp(e);

            if (e.KeyCode == Keys.Back || e.KeyCode == Keys.Delete)
                SetNullVal();
        }

        protected override void OnMouseDown(MouseEventArgs e)
        {
            if (this.Text == string.Empty)
                _cancelEdit = true;
            base.OnMouseDown(e);
        }

        protected override void OnTextChanged(EventArgs e)
        {
            if (_cancelEdit)
                SetNullVal();
            base.OnTextChanged(e);
        }

        protected override void OnMouseUp(MouseEventArgs e)
        {
            if(_cancelEdit)
                new Task(async () =>
                {
                    await Task.Delay(50);
                    SetNullVal();
                    _cancelEdit = false;
                }).RunSynchronously();
            base.OnMouseUp(e);
        }

        void SetNullVal()
        {
            this.Value = DBNull.Value;
            this.Text = string.Empty;
        }
    }
}
